C To interactively solve electron diffraction patterns
C   given a pair of reciprocal lattice vectors of unknown
C   indices, and an acute angle between these vectors
C   The d-spacings of these vectors can be input, or just a ratio
C   of their magnitudes.
C
C
C The metric tensor F converts the components from reciprocal to
C  real space. 
C The metric tensor G converts the components from real to reciprocal
C  space, and G is the inverse of F and vice-versa.
C
C ACCU is the measurement accuracy expressed as a fraction
C GV1 and GV2 are the d-spacings corresponding to the two input vectors
C
      SUBROUTINE MAP_CRYSTAL_ED1(F,ACCU,AAA,PI,GV1,GV2,RR,J21,
     &JTYPE,AH,AK,AL,AAD,AHH,AKK,ALL,ABD,AU1,AV1,AW1,AAX,JA)
      IMPLICIT NONE
      REAL F(9),ACCU,AAA,PI,GV1,GV2,RR,AH(400),AK(400),
     &AL(400),AAD(400),AHH(400),AKK(400),ALL(400),ABD(400),AU1(400),
     &AV1(400),AW1(400),AAX(400),AA,H,K,L,HH,KK,LL,AD,BD,U1,V1,W1,AX
      INTEGER J20,J21,J22,JI,JA,I1,I2,I3,JTYPE,J1,J2,J3
C
C
        J22=J21+1
        J20=2*J21+1
        J21=-J21-1
C
      IF(ACCU .GT. 0.08) ACCU=0.08
C
C
      RR=GV1/GV2
C
C
      IF(RR .GE. 1.0) GOTO 8
      RR=1.0/RR
C Convert angle to radians
8     AA=AAA*PI/180.0
C 
C Systematically vary the Miller indices of the pair of input
C  vectors, so that the trial vectors can be tested against
C  those input, with respect to magnitude and angle
C
C
      JI=1
C
C
      DO 1 I1=1,J22
        H=I1-1
          DO 2 I2=1,J20
            K=I2+J21
              DO 3 I3=1,J20
                L=I3+J21
                 DO 4 J1=1,J22
                  HH=J1-1
                    DO 5 J2=1,J20
                      KK=J2+J21
                        DO 6 J3=1,J20
                         LL=J3+J21
C
      IF(H.EQ.0.AND.K.EQ.0.AND.L.EQ.0)GOTO6
      IF(HH.EQ.0.AND.KK.EQ.0.AND.LL.EQ.0)GOTO6
      IF(HH.EQ.H.AND.KK.EQ.K.AND.LL.EQ.L)GOTO6
      IF(-1*HH.EQ.H.AND.-1*KK.EQ.K.AND.-1*LL.EQ.L)GOTO6
C
      CALL MAP_CRYSTAL_TEST1(ACCU,F,GV1,GV2,RR,AA,H,K,L,
     &HH,KK,LL,JTYPE,AD,BD,U1,V1,W1,AX,PI)
C
C
      AH(JI)=H
      AK(JI)=K
      AL(JI)=L
      AAD(JI)=AD
      AHH(JI)=HH
      AKK(JI)=KK
      ALL(JI)=LL
      ABD(JI)=BD
      AU1(JI)=U1
      AV1(JI)=V1
      AW1(JI)=W1
      AAX(JI)=AX
      JI=JI+1

C
6                               CONTINUE
5                             CONTINUE
4                          CONTINUE
3                      CONTINUE
2                  CONTINUE
1               CONTINUE
C
C
      JA=JI
      RETURN
      END
